import "./css/App.css";
import {Routes, Route } from 'react-router-dom';

import Main from "./pages/Main.js";
import Login from "./pages/Login.js";
import Search from "./pages/Search.js";
import PostWrite from "./pages/PostWrite.js"

import Header from "./components/Header.js";
import GoogleLoginButton from "./components/GoogleLoginButton.js";
import React, { useEffect, useState, useContext} from 'react';
import { UserContext } from './Usercontext.js';

function App() {
	
	const [ myName, setMyName] = useState(null);
	
  return(
    <div className="App">
		<UserContext.Provider value={setMyName}>
			<Header user={myName}></Header>
			<Routes>
				<Route path="/" element={<Main/>}></Route>
				<Route path="/login" element={<Login/>}></Route>
				<Route path="/search" element={<Search/>}></Route>
			{<Route path="/postwrite" element={<PostWrite/>}></Route> }
			</Routes>
		</UserContext.Provider>
		{/* <Footer/> */}
    </div>
    );
}

export default App;